> For the complete documentation index, see [llms.txt](https://developers-apps-in-toss.toss.im/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.getproductitemlist.md).

# IAP.getProductItemList

### 功能说明

获取可通过应用内购买购买的商品列表。进入商品列表页面时调用。

Toss App Android/iOS `5.219.0` 及以上版本可使用。在不支持的版本中调用时 `UNSUPPORTED_APP_VERSION` 会发生错误。

### 类型

```ts
IAP.getProductItemList(): Promise<{ products: IapProductListItem[] }>;
```

**参数**

无

**响应**

```ts
type ConsumableProductListItem = {
  sku: string;
  type: "CONSUMABLE";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
};

type NonConsumableProductListItem = {
  sku: string;
  type: "NON_CONSUMABLE";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
};

type Offer =
  | { type: "FREE_TRIAL"; offerId: string; period: string }
  | {
      type: "NEW_SUBSCRIPTION";
      offerId: string;
      period: string;
      displayAmount: string;
    }
  | {
      type: "RETURNING";
      offerId: string;
      period: string;
      displayAmount: string;
    };

type SubscriptionProductListItem = {
  sku: string;
  type: "SUBSCRIPTION";
  displayName: string;
  displayAmount: string;
  iconUrl: string;
  description: string;
  renewalCycle: "WEEKLY" | "MONTHLY" | "YEARLY";
  offers?: Offer[];
};

type IapProductListItem =
  | ConsumableProductListItem
  | NonConsumableProductListItem
  | SubscriptionProductListItem;
```

### 错误

错误代码是 catch 到的错误的 `error.code` 值。

| 代码                        | 说明                                                                                                                    |
| ------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| `UNSUPPORTED_APP_VERSION` | 如果当前运行的 Toss App 版本不支持此功能，则调用后会立即发生。 `IAP.getProductItemList.isSupported()`请先通过它确认，发生时 `error.message`请向用户显示（更新提示文案）。 |

### 示例代码

```js
import { IAP } from "@apps-in-toss/web-framework";

async function renderProductList() {
  try {
    const response = await IAP.getProductItemList();
    const list = document.querySelector("#product-list");

    for (const product of response.products) {
      const item = document.createElement("li");
      item.textContent = `${product.displayName} · ${product.displayAmount}`;
      list.appendChild(item);
    }
  } catch (error) {
    console.error(error);
  }
}

renderProductList();
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers-apps-in-toss.toss.im/documentation/api-and-sdk-zh/sdk/domains-api/ying-yong-nei-gou-mai/iap.getproductitemlist.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
